--
-- Mod: Display Date 4 Seasons Mod
--
-- Author: D3r1L
-- email: 
-- @Date: 22.08.2019
-- @Version: 1.0.0.5
-- Copyright (C) D3r1L, All Rights Reserved.

DisplayDate4Seasons = {}

local modDesc = loadXMLFile("modDesc", g_currentModDirectory .. "modDesc.xml")

language = {}

fontSize = 0.017
fontSizeChange = 0.001
moveListChange = 0.004

posXList = 0.72
posYList = 0.84

DisplayDate4Seasons.formatDate = 1
DisplayDate4Seasons.displayDry = true
DisplayDate4Seasons.displayList = false
DisplayDate4Seasons.displaySeason = true

-- Settings
DisplayDate4Seasons.settingsDir = ""
DisplayDate4Seasons.savegameFold = ""

addModEventListener(DisplayDate4Seasons)
--[[
local oldSetDate = g_seasons.ui.hud.setDate
g_seasons.ui.hud.setDate = function(self)
	local newSetDate = oldSetDate(self, 2, 2)
end
--]]
function DisplayDate4Seasons:loadMap(name)
--if g_seasons ~= nil then -- g_seasons, g_currentMission, Environment, FSBaseMission, Bga, g_i18n, Placeable
	--print("[g_seasons.economy.mission.tipTriggers LVL 2]")
	--DebugUtil.printTableRecursively(g_seasons.economy.mission.tipTriggers, "-", 0, 2)
	--DebugUtil.printTableRecursively(g_currentMission.inGameMenu.pagePrices.pricesTable, "-", 0, 5)
--end
	--inputsActive = false
	g_seasons.ui.hud.drawDateText = Utils.prependedFunction(g_seasons.ui.hud.drawDateText, DisplayDate4Seasons.drawDateText)
	--g_seasons.ui.hud.setDate = Utils.appendedFunction(g_seasons.ui.hud.setDate, DisplayDate4Seasons.setDate)
	
	local savegameDir
	--local savegameFold
	local savegameFolder
	if g_currentMission.missionInfo.savegameDirectory then
		savegameDir = g_currentMission.missionInfo.savegameDirectory
	end
	if not savegameDir and g_careerScreen.currentSavegame and g_careerScreen.currentSavegame.savegameIndex then
		savegameDir = ('%ssavegame%d'):format(getUserProfileAppPath(), g_careerScreen.currentSavegame.savegameIndex)
	end
	if not savegameDir and g_currentMission.missionInfo.savegameIndex ~= nil then
		savegameDir = ('%ssavegame%d'):format(getUserProfileAppPath(), g_careerScreen.missionInfo.savegameIndex)
	end
	for savegameFolder in string.gmatch(savegameDir, '([^/]+)') do
		--print("--------------- DisplayDate4Seasons.savegameDir: " .. savegameFolder)
		DisplayDate4Seasons.savegameFold = savegameFolder .. "/"
	end
	
	-- Settings
	DisplayDate4Seasons.settingsDir = getUserProfileAppPath() .. "modsSettings/DisplayDate4Seasons/"
	
	DisplayDate4Seasons:LoadSettings()
	
end

function DisplayDate4Seasons:LoadSettings()
	
	local file = DisplayDate4Seasons.settingsDir .. DisplayDate4Seasons.savegameFold .. "DisplayDate4Seasons.xml"
	
	local pos = 0
	local rootPath = "DisplayDate4Seasons.settings"
	local groupNameTag = string.format("%s.setting(%d)", rootPath, pos)
	
	if fileExists(file) then
		---- Load
		local xmlContent = loadXMLFile("DisplayDate4Seasons_XML", file, "DisplayDate4Seasons")
		
		fontSize = Utils.getNoNil(getXMLFloat(xmlContent, groupNameTag .. "#listSize"), 0.017)
		
		posXList = Utils.getNoNil(getXMLFloat(xmlContent, groupNameTag .. "#posXList"), 0.72)
		posYList = Utils.getNoNil(getXMLFloat(xmlContent, groupNameTag .. "#posYList"), 0.85)
		
		DisplayDate4Seasons.formatDate = Utils.getNoNil(getXMLInt(xmlContent, groupNameTag .. "#formatDate"), 1)
		DisplayDate4Seasons.displayDry = Utils.getNoNil(getXMLBool(xmlContent, groupNameTag .. "#displayDry"), true)
		DisplayDate4Seasons.displaySeason = Utils.getNoNil(getXMLBool(xmlContent, groupNameTag .. "#displaySeason"), true)
		DisplayDate4Seasons.displayList = Utils.getNoNil(getXMLBool(xmlContent, groupNameTag .. "#displayList"), false)
		
	else
		createFolder(getUserProfileAppPath() .. "modsSettings/")
		createFolder(DisplayDate4Seasons.settingsDir)
		createFolder(DisplayDate4Seasons.settingsDir .. DisplayDate4Seasons.savegameFold)
		
		---- Create
		local xmlContent = createXMLFile("DisplayDate4Seasons_XML", file, "DisplayDate4Seasons")
		
		setXMLFloat(xmlContent, groupNameTag .. "#listSize", fontSize) -- set here the currentFontSize
		
		setXMLFloat(xmlContent, groupNameTag .. "#posXList", posXList)
		setXMLFloat(xmlContent, groupNameTag .. "#posYList", posYList)
		
		setXMLInt(xmlContent, groupNameTag .. "#formatDate", DisplayDate4Seasons.formatDate)
		setXMLBool(xmlContent, groupNameTag .. "#displayDry", DisplayDate4Seasons.displayDry)
		setXMLBool(xmlContent, groupNameTag .. "#displaySeason", DisplayDate4Seasons.displaySeason)
		setXMLBool(xmlContent, groupNameTag .. "#displayList", DisplayDate4Seasons.displayList)
		
		saveXMLFile(xmlContent)
		--delete(xmlContent)
	end
end

function DisplayDate4Seasons:SaveSettings()
	
	createFolder(getUserProfileAppPath() .. "modsSettings/")
	createFolder(DisplayDate4Seasons.settingsDir)
	createFolder(DisplayDate4Seasons.settingsDir .. DisplayDate4Seasons.savegameFold)
	
	local file = DisplayDate4Seasons.settingsDir .. DisplayDate4Seasons.savegameFold .. "DisplayDate4Seasons.xml"
	local pos = 0
	local rootPath = "DisplayDate4Seasons.settings"
	local groupNameTag = string.format("%s.setting(%d)", rootPath, pos)
	
	local xmlContent = createXMLFile("DisplayDate4Seasons_XML", file, "DisplayDate4Seasons")
	
	setXMLFloat(xmlContent, groupNameTag .. "#listSize", fontSize) -- set here the currentFontSize
	
	setXMLFloat(xmlContent, groupNameTag .. "#posXList", posXList)
	setXMLFloat(xmlContent, groupNameTag .. "#posYList", posYList)
	
	setXMLInt(xmlContent, groupNameTag .. "#formatDate", DisplayDate4Seasons.formatDate)
	setXMLBool(xmlContent, groupNameTag .. "#displayDry", DisplayDate4Seasons.displayDry)
	setXMLBool(xmlContent, groupNameTag .. "#displaySeason", DisplayDate4Seasons.displaySeason)
	setXMLBool(xmlContent, groupNameTag .. "#displayList", DisplayDate4Seasons.displayList)
	
	saveXMLFile(xmlContent)
	--delete(xmlContent)
	
end

function DisplayDate4Seasons:update(dt)
	if g_currentMission:getIsClient() then
		if g_gui.currentGui == nil then -- and g_currentMission.controlledVehicle == nil then
			---- SELECT FORMAT DATE
			local _1, eventFormatLayout = g_currentMission.inputManager:registerActionEvent(InputAction.FormatLayout, DisplayDate4Seasons, DisplayDate4Seasons.FormatLayout, false, true, false, true) --, false, true, false, true)
			if g_inputBinding ~= nil and g_inputBinding.events ~= nil and g_inputBinding.events[eventFormatLayout] ~= nil then 
				g_inputBinding.events[eventFormatLayout].displayIsVisible = false 
			end
			---- SHOW DISPLAY DRY
			local _1, eventShowDryPower = g_currentMission.inputManager:registerActionEvent(InputAction.ShowDryPower, DisplayDate4Seasons, DisplayDate4Seasons.ShowDryPower, false, true, false, true) --, false, true, false, true)
			if g_inputBinding ~= nil and g_inputBinding.events ~= nil and g_inputBinding.events[eventShowDryPower] ~= nil then 
				g_inputBinding.events[eventShowDryPower].displayIsVisible = false 
			end
			---- SHOW DISPLAY SEASON
			local _1, eventShowSeasonInfo = g_currentMission.inputManager:registerActionEvent(InputAction.ShowSeasonInfo, DisplayDate4Seasons, DisplayDate4Seasons.ShowSeasonInfo, false, true, false, true) --, false, true, false, true)
			if g_inputBinding ~= nil and g_inputBinding.events ~= nil and g_inputBinding.events[eventShowSeasonInfo] ~= nil then 
				g_inputBinding.events[eventShowSeasonInfo].displayIsVisible = false 
			end
			---- SHOW LIST PRICES
			local _1, eventShowListPrices = g_currentMission.inputManager:registerActionEvent(InputAction.ShowListPrices, DisplayDate4Seasons, DisplayDate4Seasons.ShowListPrices, false, true, false, true) --, false, true, false, true) 
			if g_inputBinding ~= nil and g_inputBinding.events ~= nil and g_inputBinding.events[eventShowListPrices] ~= nil then 
				g_inputBinding.events[eventShowListPrices].displayIsVisible = false 
			end
			if DisplayDate4Seasons.displayList then
				---- INCREASE LIST PRICES
				local _1, eventIncreaseListSize = g_currentMission.inputManager:registerActionEvent(InputAction.increaseListSize, DisplayDate4Seasons, DisplayDate4Seasons.FontSizeIncrease, false, true, false, true) --, false, true, false, true)
				if g_inputBinding ~= nil and g_inputBinding.events ~= nil and g_inputBinding.events[eventIncreaseListSize] ~= nil then 
					g_inputBinding.events[eventIncreaseListSize].displayIsVisible = false 
				end
				---- DECREASE LIST PRICES
				local _1, eventDecreaseListSize = g_currentMission.inputManager:registerActionEvent(InputAction.decreaseListSize, DisplayDate4Seasons, DisplayDate4Seasons.FontSizeDecrease, false, true, false, true) --, false, true, false, true)
				if g_inputBinding ~= nil and g_inputBinding.events ~= nil and g_inputBinding.events[eventDecreaseListSize] ~= nil then 
					g_inputBinding.events[eventDecreaseListSize].displayIsVisible = false 
				end
				---- MOVE UP LIST PRICES
				local _1, eventMoveUpListSize = g_currentMission.inputManager:registerActionEvent(InputAction.moveUpList, DisplayDate4Seasons, DisplayDate4Seasons.moveUpList, false, true, false, true) --, false, true, false, true)
				if g_inputBinding ~= nil and g_inputBinding.events ~= nil and g_inputBinding.events[eventMoveUpListSize] ~= nil then 
					g_inputBinding.events[eventMoveUpListSize].displayIsVisible = false 
				end
				---- MOVE DOWN LIST PRICES
				local _1, eventMoveDownListSize = g_currentMission.inputManager:registerActionEvent(InputAction.moveDownList, DisplayDate4Seasons, DisplayDate4Seasons.moveDownList, false, true, false, true) --, false, true, false, true)
				if g_inputBinding ~= nil and g_inputBinding.events ~= nil and g_inputBinding.events[eventMoveDownListSize] ~= nil then 
					g_inputBinding.events[eventMoveDownListSize].displayIsVisible = false 
				end
				---- MOVE LEFT LIST PRICES
				local _1, eventMoveLeftListSize = g_currentMission.inputManager:registerActionEvent(InputAction.moveLeftList, DisplayDate4Seasons, DisplayDate4Seasons.moveLeftList, false, true, false, true) --, false, true, false, true)
				if g_inputBinding ~= nil and g_inputBinding.events ~= nil and g_inputBinding.events[eventMoveLeftListSize] ~= nil then 
					g_inputBinding.events[eventMoveLeftListSize].displayIsVisible = false 
				end
				---- MOVE RIGHT LIST PRICES
				local _1, eventMoveRightListSize = g_currentMission.inputManager:registerActionEvent(InputAction.moveRightList, DisplayDate4Seasons, DisplayDate4Seasons.moveRightList, false, true, false, true) --, false, true, false, true)
				if g_inputBinding ~= nil and g_inputBinding.events ~= nil and g_inputBinding.events[eventMoveRightListSize] ~= nil then 
					g_inputBinding.events[eventMoveRightListSize].displayIsVisible = false 
				end
			end
		end
	end
end
--[[
function DisplayDate4Seasons:keyEvent(unicode, sym, modifier, isDown)
	if g_server ~= nil and g_client ~= nil and g_dedicatedServerInfo ~= nil then
		return
	end
	print("Keypress : " .. tostring(InputBinding.ShowSeasonPrices))
	if Input.isKeyPressed(InputBinding.ShowSeasonPrices) then
		DisplayDate4Seasons.displayList = not DisplayDate4Seasons.displayList
	end
end
--]]
function DisplayDate4Seasons:FormatLayout()
	if DisplayDate4Seasons.formatDate == 1 then
		DisplayDate4Seasons.formatDate = 2
	elseif DisplayDate4Seasons.formatDate == 2 then
		DisplayDate4Seasons.formatDate = 3
	elseif DisplayDate4Seasons.formatDate == 3 then
		DisplayDate4Seasons.formatDate = 4
	elseif DisplayDate4Seasons.formatDate == 4 then
		DisplayDate4Seasons.formatDate = 5
	elseif DisplayDate4Seasons.formatDate == 5 then
		DisplayDate4Seasons.formatDate = 1
	end
	DisplayDate4Seasons:SaveSettings()
	--DisplayDate4Seasons:LoadSettings()
end

function DisplayDate4Seasons:ShowDryPower()
	DisplayDate4Seasons.displayDry = not DisplayDate4Seasons.displayDry
	--[[
	if DisplayDate4Seasons.displayDry == 2 then
		DisplayDate4Seasons.displayDry = 1
	elseif DisplayDate4Seasons.displayDry == 1 then
		DisplayDate4Seasons.displayDry = 0
	elseif DisplayDate4Seasons.displayDry == 0 then
		DisplayDate4Seasons.displayDry = 2
	end
	]]--
	DisplayDate4Seasons:SaveSettings()
	--DisplayDate4Seasons:LoadSettings()
end

function DisplayDate4Seasons:ShowSeasonInfo()
	DisplayDate4Seasons.displaySeason = not DisplayDate4Seasons.displaySeason
	DisplayDate4Seasons:SaveSettings()
	--DisplayDate4Seasons:LoadSettings()
end

function DisplayDate4Seasons:ShowListPrices()
	DisplayDate4Seasons.displayList = not DisplayDate4Seasons.displayList
	DisplayDate4Seasons:SaveSettings()
	--DisplayDate4Seasons:LoadSettings()
end

function DisplayDate4Seasons:FontSizeIncrease()
	if DisplayDate4Seasons.displayList then
		fontSize = fontSize + fontSizeChange
		DisplayDate4Seasons:SaveSettings()
		--DisplayDate4Seasons:LoadSettings()
	end
end

function DisplayDate4Seasons:FontSizeDecrease()
	if DisplayDate4Seasons.displayList then
		fontSize = fontSize - fontSizeChange
		DisplayDate4Seasons:SaveSettings()
		--DisplayDate4Seasons:LoadSettings()
	end
end

function DisplayDate4Seasons:moveUpList()
	if DisplayDate4Seasons.displayList then
		posYList = posYList + moveListChange
		DisplayDate4Seasons:SaveSettings()
		--DisplayDate4Seasons:LoadSettings()
	end
end

function DisplayDate4Seasons:moveDownList()
	if DisplayDate4Seasons.displayList then
		posYList = posYList - moveListChange
		DisplayDate4Seasons:SaveSettings()
		--DisplayDate4Seasons:LoadSettings()
	end
end

function DisplayDate4Seasons:moveRightList()
	if DisplayDate4Seasons.displayList then
		posXList = posXList + moveListChange
		DisplayDate4Seasons:SaveSettings()
		--DisplayDate4Seasons:LoadSettings()
	end
end

function DisplayDate4Seasons:moveLeftList()
	if DisplayDate4Seasons.displayList then
		posXList = posXList - moveListChange
		DisplayDate4Seasons:SaveSettings()
		--DisplayDate4Seasons:LoadSettings()
	end
end

function DisplayDate4Seasons:draw()
    if g_seasons == nil or g_dedicatedServerInfo ~= nil or not g_currentMission.renderTime or not g_currentMission.hud.showTime then
		return
	end
	
  local r, g, b, a = self:getColor("white")
  setTextColor(r, g, b, a)
  local fontSize = (g_gameSettings:getValue("uiScale") *  0.015)
  --print(string.format('CITY ECONMY fontSize:'..tostring(fontSize)))
  fontSize = fontSize * 0.9
  --local date = getDate(self.timeFormat)
  local posX = 0.73 -- 0.9
  local posY = 0.98
  local myDay = 0
  local mese = "mese"
  local weekDay = "weekDay"
  local myPeriod = g_seasons.weather.forecast.environment.period
  local daysPerMouth = g_seasons.weather.forecast.environment.daysPerSeason / 3
  --local anno = "" --tonumber(date) + g_seasons.weather.forecast.environment.year
	local dayInSeason = g_seasons.environment.dayInSeason
	
	---- Date (skipped by myDate > 0)
	if myDay > 0 then --DisplayDate4Seasons.displayDry > 0 then
		if daysPerMouth == 1 then
			myDay = 13 + dayInSeason
		elseif daysPerMouth == 2 then
			myDay = 13 + dayInSeason
		elseif daysPerMouth == 3 then
			myDay = 11 + dayInSeason
		elseif daysPerMouth == 4 then
			myDay = 10 + dayInSeason
		elseif daysPerMouth == 5 then
			myDay = 8 + dayInSeason
		elseif daysPerMouth == 6 then
			myDay = 6 + dayInSeason
		elseif daysPerMouth == 7 then
			myDay = 4 + dayInSeason
		elseif daysPerMouth == 8 then
			myDay = 2 + dayInSeason
		end
		
		if myPeriod == 1 then
			mese = g_i18n:getText("showMonth1")
		elseif myPeriod == 2 then
			mese = g_i18n:getText("showMonth2")
		elseif myPeriod == 3 then
			mese = g_i18n:getText("showMonth3")
		elseif myPeriod == 4 then
			mese = g_i18n:getText("showMonth4")
		elseif myPeriod == 5 then
			mese = g_i18n:getText("showMonth5")
		elseif myPeriod == 6 then
			mese = g_i18n:getText("showMonth6")
		elseif myPeriod == 7 then
			mese = g_i18n:getText("showMonth7")
		elseif myPeriod == 8 then
			mese = g_i18n:getText("showMonth8")
		elseif myPeriod == 9 then
			mese = g_i18n:getText("showMonth9")
		elseif myPeriod == 10 then
			mese = g_i18n:getText("showMonth10")
		elseif myPeriod == 11 then
			mese = g_i18n:getText("showMonth11")
		elseif myPeriod == 12 then
			mese = g_i18n:getText("showMonth12")
		end
		
		local diffWeekDay = math.floor(g_seasons.environment.currentDay / 7)
		local currWeekDay = g_seasons.environment.currentDay - (diffWeekDay * 7)
		
		if currWeekDay == 0 then
			currWeekDay = 7
		end
		
		--print("diffWeekDay: " .. tostring(diffWeekDay))
		--print("currWeekDay: " .. tostring(currWeekDay))
		
		if currWeekDay == 1 then
			weekDay = g_i18n:getText("showWeekDay1")
		elseif currWeekDay == 2 then
			weekDay = g_i18n:getText("showWeekDay2")
		elseif currWeekDay == 3 then
			weekDay = g_i18n:getText("showWeekDay3")
		elseif currWeekDay == 4 then
			weekDay = g_i18n:getText("showWeekDay4")
		elseif currWeekDay == 5 then
			weekDay = g_i18n:getText("showWeekDay5")
		elseif currWeekDay == 6 then
			weekDay = g_i18n:getText("showWeekDay6")
		elseif currWeekDay == 7 then
			weekDay = g_i18n:getText("showWeekDay7")
		end
		
		local myDate = mese .. ", " .. weekDay .. " " .. tostring(myDay)
		local width = getTextWidth(fontSize, myDate)
		--local height = getTextHeight(fontSize, myDate)
		posX = 0.762 -- - width
		setTextBold(true)
		
		setTextAlignment(RenderText.ALIGN_CENTER)
		--renderText(posX, posY, fontSize, "Gennaio, ") -- .. tostring(date))
		renderText(posX, posY, fontSize, myDate)
	end
	
	---- Show Season Info
    if DisplayDate4Seasons.displaySeason then -- 2 then
		--local currentPeriod = g_seasons.environment.period
		--local currentCategory = g_seasons.environment.latitudeCategories[g_seasons.environment:latitudeCategory()]
		--local currentVisual = currentCategory[myPeriod]
		--local visualSeasonsId = g_seasons.environment.seasonKeyToId[currentVisual]
		
		--print("visualSeasonsId = " .. tostring(myGEOseason))
		
		local myGEOseason = "GEO"
		--local myGEOseason = string.format("%02d/%s", dayInSeason, g_seasons.i18n:getText("seasons_periodNameFull_" .. myPeriod)) 
		--local myGEOseason = "(" .. g_seasons.i18n:getText("seasons_periodNameFull_" .. myPeriod) .. ")"
		-- "GEO: " .. g_seasons.i18n:getText("seasons_periodNameFull_" .. tostring(visualSeasonsId)) 
		-- g_seasons.environment:getCurrentVisualSeason(myPeriod)
		
		--print("myGEOseason = " .. tostring(myGEOseason))
		
		local width = getTextWidth(fontSize, myGEOseason)
		--local height = getTextHeight(fontSize, myDate)
		posX = 0.705 --0.762 -- - width
		setTextBold(true)
		
		setTextAlignment(RenderText.ALIGN_CENTER)
		renderText(posX, posY, fontSize, myGEOseason)
	end
	
	---- Show Drying Potential
    if DisplayDate4Seasons.displayDry then -- 2 then
		local today = g_seasons.environment.currentDay
		local currentHour = g_seasons.weather.forecast.environment.mission.environment.currentHour
		
		--- Lower to nearest block
		local currentTimeBlock = math.floor(currentHour / 3) * 3
		
		--print("today = " .. today)
		--print("currentHour = " .. currentHour)
		--print("currentTimeBlock = " .. currentTimeBlock)
		
		-- Drying Potential
		for i = 1, 16 do
			local day, time, duration = today, 0, 3

			-- Do slots first, then do days
			if i <= 10 then
				time = currentTimeBlock + (i - 1) * 3
				if time >= 24 then
					time = time - 24
					day = day + 1
				end
			else
				day = day + (i - 10)
				duration = 24
			end
			
			--print("day = " .. tostring(day) .. " - time = " .. tostring(time) .. " - duration = " .. tostring(duration))
			
			local forecastInfo = g_seasons.weather:getForecast(day, time, duration)
			
			local dryingGrass = ""
			if forecastInfo.dryingPotential <= -9 then
				dryingGrass = "(++)"
			elseif forecastInfo.dryingPotential <= -2 then
				dryingGrass = "(+)"
			elseif forecastInfo.dryingPotential <= 0.2 then
				dryingGrass = "(0)"
			elseif forecastInfo.dryingPotential <= 2 then
				dryingGrass = "(-)"
			else
				dryingGrass = "(--)"
			end
			
			--print("dryingGrass = " .. tostring(dryingGrass))
			posY = 0.98
			fontSize = (g_gameSettings:getValue("uiScale") *  0.015)
			--fontSize = fontSize * 1.1
			width = getTextWidth(fontSize, dryingGrass)
			setTextAlignment(RenderText.ALIGN_CENTER)
			setTextWrapWidth(0)
			setTextBold(true)
			--local height = getTextHeight(fontSize, myDate)
			posX = 0.625 -- - width
			renderText(posX, posY, fontSize, dryingGrass)
			setTextWrapWidth(0)
			break
		end
	end
	
	---- Products List
	if DisplayDate4Seasons.displayList then
		drawInfo()
	end
	
end

function DisplayDate4Seasons:getColor(source)
  local color = source:lower()
  if color == "white" then
    return 1, 1, 1, 1
  elseif color == "black" then
    return 0, 0, 0, 1
  else
    local splitted = Utils.splitString(",", color)
    local colors = {}
    for _, v in pairs(splitted) do
      table.insert(colors, tonumber(v))
    end
    return unpack(colors)
  end
end

function drawInfo()
    
	-------------------------------------------------
	-- setting for screen render
	-------------------------------------------------
	linePadding = 0.003
	paddingBetweenLines = fontSize + 0.004
	setTextColor(1,1,1,1)
	local position_X_Standard = 0.72
	local position_X_StandardOffsetRight = 0.12
	local position_X_StandardCombi = 0.81
	local position_X_StandardCombiOffsetRight = 0.16

	local position_Y_Standard = 0.85

	local position_X_extendedWindow = 0.75
	local position_X_extendedWindowOffsetRight = 0.14

	local position_X_extendedWindowCombi = 0.67
	local position_X_extendedWindowCombiOffsetRight = 0.16

	posY = posYList --position_Y_Standard -- all huds have the same start hight
	
	--if combiFillLevelActive == true then 
	--	posX = position_X_StandardCombi
	--	posX2 = posX + position_X_StandardCombiOffsetRight
	--else 
		posX = posXList --position_X_Standard
	--end
	
	---- Titolo
	setTextBold(true)
	setTextColor(0,1,1,1) -- blue
	
	setTextAlignment(RenderText.ALIGN_LEFT)
	renderText(posX, posY, fontSize, "Products") -- first item -- RENDER THE TITLE WITH ALIGNMENT LEFT. EXAMPLE "WHEAT: or Count of Animals"
	
	setTextAlignment(RenderText.ALIGN_RIGHT)
	local widthMaxPrice = getTextWidth(fontSize, "Products") + getTextWidth(fontSize, "     Cur Price") -- 0.05
	renderText(posX + widthMaxPrice, posY, fontSize, "Cur Price")
	
	setTextAlignment(RenderText.ALIGN_LEFT)
	local widthBestPeriod = widthMaxPrice + getTextWidth(fontSize, " - ")
	renderText(posX + widthBestPeriod, posY, fontSize, "Best Period")
	
	setTextAlignment(RenderText.ALIGN_RIGHT)
	local widthBestPrice = widthBestPeriod + getTextWidth(fontSize, " - Best Period     Adv Price")
	renderText(posX + widthBestPrice, posY, fontSize, "Adv Price")
	
	setTextBold(false)
	setTextColor(1,1,1,1) -- white
	
	local k = 0
	fillPrices = {}
	trenPrices = {}
	bestPrices = {}
	
	for _,fillType in pairs(g_currentMission.fillTypeManager.fillTypes) do
		
		if fillType.name == "WHEAT" or fillType.name == "BARLEY" or fillType.name == "OAT" or
			fillType.name == "COTTON" or fillType.name == "CANOLA" or fillType.name == "SUNFLOWER" or
			fillType.name == "SOYBEAN" or fillType.name == "MAIZE" or fillType.name == "POTATO" or
			fillType.name == "SUGARBEET" or fillType.name == "WOODCHIPS" or fillType.name == "SUGARCANE" or
			fillType.name == "MILK" or fillType.name == "WOOL" or fillType.name == "EGG" then
		-- ]]
		--if fillType.name == "MILK" then
			
			for _,sellingStation in pairs(g_currentMission.storageSystem.unloadingStations) do
				
				if sellingStation.isSellingPoint ~= nil and sellingStation.isSellingPoint == true then
					
					for i, isFillType in pairs(sellingStation.acceptedFillTypes) do
					--print("sellingStation.acceptedFillTypes = " .. tostring(sellingStation.acceptedFillTypes))
						
						--fillType = g_currentMission.fillTypeManager:getFillTypeByName(g_currentMission.fillTypeManager:getFillTypeNameByIndex(i))
						fillTypeStation = g_currentMission.fillTypeManager:getFillTypeByName(g_currentMission.fillTypeManager:getFillTypeNameByIndex(i))
						
						if fillTypeStation == fillType then
						
					--if sellingStation.acceptedFillTypes ~= nil then
						--for _,fillType in pairs(sellingStation.acceptedFillTypes) do
						--for _,fillType in pairs(g_currentMission.fillTypeManager.fillTypes) do
							--posY = posY - getTextHeight(fontSize, "Products")
							--renderText(posX, posY, fontSize, sellingStation.stationName)
							--print("fillType = " .. tostring(fillType.name))
							--print("Price = " .. tostring(sellingStation.fillTypePrices[i]))
							
							if sellingStation.fillTypePrices[i] ~= nil then
								--g_currentMission.fillTypeManager.fillTypes[fillType].name))
							--if sellingStation.acceptedFillTypes[fillType] ~= nil then -- and fillType == sellingStation.acceptedFillTypes[fillType] then
								--if sellingStation.fillTypePrices[fillType.index] ~= nil then
								--	setTextAlignment(RenderText.ALIGN_LEFT)
								--	posY = posY - getTextHeight(fontSize, "Products")
								--	renderText(posX, posY, fontSize, fillType.title)
									
									--print("sellingStation.fillTypePrices[fillType] = " .. tostring(sellingStation.fillTypePrices[fillType]))
									--print("g_seasons.economy.data:getFillTypeFactor(fillType) = " .. tostring(g_seasons.economy.data:getFillTypeFactor(fillType)))
									--print("sellingStation.fillTypePriceRandomDelta[fillType] = " .. tostring(sellingStation.fillTypePriceRandomDelta[fillType]))
									--print("g_seasons.economy.RANDOM_IMPACT = " .. tostring(g_seasons.economy.RANDOM_IMPACT))
									--print("EconomyManager.getPriceMultiplier() = " .. tostring(EconomyManager.getPriceMultiplier()))
									
								--	print("sellingStation.fillTypePrices[fillType] = " .. tostring(sellingStation.fillTypePrices[fillType]))
									--local per1000Price = sellingStation.fillTypePrices[fillType] * 1000
									local per1000Price = sellingStation:getEffectiveFillTypePrice(i) * 1000
									--local per1000Price = ((sellingStation.fillTypePrices[fillType] * g_seasons.economy.data:getFillTypeFactor(fillType) + sellingStation.fillTypePriceRandomDelta[fillType] * g_seasons.economy.RANDOM_IMPACT) * sellingStation.priceMultipliers[fillType]) * EconomyManager.getPriceMultiplier() * 1000
									
									--local trendPrice = sellingStation:getCurrentPricingTrend(fillType.index)
									--print("fillType = " .. fillType.name .. " | Price = " .. tostring(round(per1000Price, 0)) .. " | trendPrice = " .. tostring(trendPrice))
									
									k = k + 1
									fillPrices[k] = math.floor(per1000Price) -- round(per1000Price, 0)
									--print("fillPrices[k] = " .. tostring(fillPrices[k] .. " k = " .. tostring(k)))
									
									local trend = 0
									if sellingStation.pricingDynamics[fillType.index]:getBaseCurveTrend() == PricingDynamics.TREND_FALLING then
										trend = -1 -- "falling"
									elseif sellingStation.pricingDynamics[fillType.index]:getBaseCurveTrend() == PricingDynamics.TREND_CLIMBING then
										trend = 1 -- "climbing"
									end
									--[[
									local correctedDelta = sellingStation.fillTypePriceRandomDelta[fillType.index] - (sellingStation.originalFillTypePrices[fillType.index] - sellingStation.fillTypePrices[fillType.index])
									if correctedDelta > sellingStation.levelThreshold then
										trend = trend + 1 --.. " high"
									elseif correctedDelta < -sellingStation.levelThreshold then
										trend = trend - 1 --.. " low"
									end
									--]]
									trenPrices[k] = trend --trendPrice
									
									--local per1000Price = fillType.pricePerLiter * 1000 -- * g_seasons.economy.data:getFillTypeFactor(fillType.index)
								--	setTextAlignment(RenderText.ALIGN_RIGHT)
								--	renderText(posX + width, posY, fontSize, tostring(round(per1000Price),0))
								--end
							end
						end
					end
				end
			end
			
			setTextColor(1, 0.8, 0, 1) -- yellow
			
			setTextAlignment(RenderText.ALIGN_LEFT)
			posY = posY - getTextHeight(fontSize, "Products")
			renderText(posX, posY, fontSize, fillType.title)
			
			setTextColor(1,1,1,1) -- white
			
			fillPrice = math.max(unpack(fillPrices))
			
			local textTrend = ""
			local bestTrend = 0
			
			for e in pairs (fillPrices) do
				if fillPrices[e] == fillPrice then
					bestTrend = trenPrices[e]
				end
				fillPrices[e] = 0
				trenPrices[e] = 0
			end
			
			--if fillType.name == "COTTON" or fillType.name == "MILK" then print("fillType = " .. fillType.title .. " - Prezzo = " .. tostring(fillPrice) .. " - Trend = " .. tostring(bestTrend)) end
			
			---- Trend Price
			if bestTrend == -2 then
				--setTextBold(true)
				setTextColor(1, 0, 0, 1) -- red
				textTrend = "↓"
			elseif bestTrend == -1 then
				setTextColor(1, 0, 0, 1) -- red
				textTrend = "↓"
			elseif bestTrend == 0 then
				
				
			elseif bestTrend == 1 then
				setTextColor(0, 1, 0, 1) -- green
				textTrend = "↑"
			elseif bestTrend == 2 then
				--setTextBold(true)
				setTextColor(0, 1, 0, 1) -- green
				textTrend = "↑"
			else
				--setTextColor(0, 0.8, 1, 1) -- blue
				--textTrend = "*"
			end
			setTextAlignment(RenderText.ALIGN_LEFT)
			renderText(posX + widthMaxPrice, posY, fontSize, textTrend)
			
			k = 0
			
			setTextColor(1,1,1,1) -- white
			
			---- Best Period/Price
			local totDays = g_seasons.weather.forecast.environment.daysPerSeason * 4
			
			--print("totDays = " .. tostring(totDays))
			
			--for i = 1, totDays, 1
			--do
			--   bestPrice = g_seasons.economy.history:getSimulatedPrice(fillType, i)
			--   --print("day = " .. tostring(i) .. " bestPrice = " .. tostring(bestPrice))
			--   bestPrices[i] = round(bestPrice, 0)
			--end
			
			local data = g_seasons.economy.history:getHistory(fillType.index)
			
			--print("data = " .. tostring(data))
			
			-- Fills Best Price
			for iDay, dayPrice in ipairs(data) do
				--bestPrice = g_seasons.economy.history:getSimulatedPrice(fillType, i)
				--print("day = " .. tostring(i) .. " bestPrice = " .. tostring(bestPrice))
				bestPrices[iDay] = round(dayPrice, 0)
				--print("iDay = " .. tostring(iDay) .. " dayPrice = " .. tostring(dayPrice))
			end
			--local min = luafp.reduce(data, math.min, math.huge)
			--local max = math.ceil(luafp.reduce(data, math.max, 0))
			
			--self.chart:setMinValue(min)
			--self.chart:setMaxValue(max)
			--self.chart:setActiveX(self.environment:currentDayInYear())
			--self.chart:setData(data)
			
			bestPrice = math.max(unpack(bestPrices))
			local day = 0
			
			--for i = 1, totDays, 1
			--do
			--	day = i
			--	if bestPrices[i] == bestPrice then
			--		--print("day = " .. tostring(day))
			--		break
			--	end
			--end
			
			for i, dayPrice in ipairs(data) do
				day = i
				if bestPrices[i] == bestPrice then
					--print("day = " .. tostring(day) .. " bestPrice = " .. tostring(bestPrice))
					break
				end
			end
			
			if fillPrice >= bestPrice then
				setTextColor(0, 1, 0, 1) -- green
			end
			
			setTextBold(false)
			
			setTextAlignment(RenderText.ALIGN_RIGHT)
			renderText(posX + widthMaxPrice, posY, fontSize, tostring(fillPrice))
			
			setTextColor(1,1,1,1) -- white
			
			local period = g_seasons.environment:periodAtDay(day)
			
			local periodLength = g_seasons.environment.daysPerSeason / 3
			--local dayInPeriod = (g_seasons.environment:dayInSeasonAtDay(day) - 1) % periodLength + 1
			local dayInPeriod = g_seasons.environment:dayInSeasonAtDay(day)
			
			--print("day = " .. tostring(day))
			--print("period = " .. tostring(period))
			
			local myPeriod = g_seasons.weather.forecast.environment.period
			local dayInSeason = g_seasons.environment.dayInSeason
			
			--print("myPeriod = " .. tostring(myPeriod))
			--print("dayInSeason = " .. tostring(dayInSeason))
			
			--print("dayInPeriod = " .. tostring(dayInPeriod))
			
			if period == 1 then
				mese = g_i18n:getText("showMonth1")
			elseif period == 2 then
				mese = g_i18n:getText("showMonth2")
			elseif period == 3 then
				mese = g_i18n:getText("showMonth3")
			elseif period == 4 then
				mese = g_i18n:getText("showMonth4")
			elseif period == 5 then
				mese = g_i18n:getText("showMonth5")
			elseif period == 6 then
				mese = g_i18n:getText("showMonth6")
			elseif period == 7 then
				mese = g_i18n:getText("showMonth7")
			elseif period == 8 then
				mese = g_i18n:getText("showMonth8")
			elseif period == 9 then
				mese = g_i18n:getText("showMonth9")
			elseif period == 10 then
				mese = g_i18n:getText("showMonth10")
			elseif period == 11 then
				mese = g_i18n:getText("showMonth11")
			elseif period == 12 then
				mese = g_i18n:getText("showMonth12")
			end
			
			local bestPeriod = mese
			
			if dayInPeriod == dayInSeason and myPeriod == period then
				setTextColor(0, 1, 0, 1) -- green
				bestPeriod = bestPeriod .. " [Now]"
			elseif dayInPeriod < dayInSeason and myPeriod == period then
				setTextColor(1, 0, 1, 1) -- purple
			elseif dayInPeriod > dayInSeason and myPeriod == period then
				setTextColor(1, 0.8, 0, 1) -- yellow
			else
				--bestPeriod = string.format("%02d/%s", dayInPeriod, g_seasons.i18n:getText("seasons_periodNameFull_" .. period))
			end
			
			setTextAlignment(RenderText.ALIGN_LEFT)
			renderText(posX + widthBestPeriod, posY, fontSize, bestPeriod)
			
			setTextAlignment(RenderText.ALIGN_RIGHT)
			renderText(posX + widthBestPrice, posY, fontSize, tostring(round(bestPrice, 0)))
			
			setTextColor(1,1,1,1) -- white
		end
	end
	--]]
	--setTextAlignment(RenderText.ALIGN_LEFT)
	--posY = posY - paddingBetweenLines
	--]]
end

function round(num, numDecimalPlaces)
  local mult = 10^(numDecimalPlaces or 0)
  return math.floor(num * mult + 0.5) / mult
end

function DisplayDate4Seasons:drawDateText()
	
	---- Only If Display Date 4 Seasons is Active
    if DisplayDate4Seasons.formatDate > 0 then
		local myDay = 0
		local myPeriod = g_seasons.weather.forecast.environment.period
		local daysPerMouth = g_seasons.weather.forecast.environment.daysPerSeason / 3
	    local myYear = getDate("%Y") + g_seasons.weather.forecast.environment.year
		local dayInSeason = g_seasons.environment.dayInSeason
		
		if daysPerMouth == 1 then
			myDay = 13 + dayInSeason
		elseif daysPerMouth == 2 then
			myDay = 13 + dayInSeason
		elseif daysPerMouth == 3 then
			myDay = 11 + dayInSeason
		elseif daysPerMouth == 4 then
			myDay = 10 + dayInSeason
		elseif daysPerMouth == 5 then
			myDay = 8 + dayInSeason
		elseif daysPerMouth == 6 then
			myDay = 6 + dayInSeason
		elseif daysPerMouth == 7 then
			myDay = 4 + dayInSeason
		elseif daysPerMouth == 8 then
			myDay = 2 + dayInSeason
		end
		
		if myPeriod == 1 then
			mese = g_i18n:getText("showMonth1")
		elseif myPeriod == 2 then
			mese = g_i18n:getText("showMonth2")
		elseif myPeriod == 3 then
			mese = g_i18n:getText("showMonth3")
		elseif myPeriod == 4 then
			mese = g_i18n:getText("showMonth4")
		elseif myPeriod == 5 then
			mese = g_i18n:getText("showMonth5")
		elseif myPeriod == 6 then
			mese = g_i18n:getText("showMonth6")
		elseif myPeriod == 7 then
			mese = g_i18n:getText("showMonth7")
		elseif myPeriod == 8 then
			mese = g_i18n:getText("showMonth8")
		elseif myPeriod == 9 then
			mese = g_i18n:getText("showMonth9")
		elseif myPeriod == 10 then
			mese = g_i18n:getText("showMonth10")
		elseif myPeriod == 11 then
			mese = g_i18n:getText("showMonth11")
		elseif myPeriod == 12 then
			mese = g_i18n:getText("showMonth12")
		end
		
		local diffWeekDay = math.floor(g_seasons.environment.currentDay / 7)
		local currWeekDay = g_seasons.environment.currentDay - (diffWeekDay * 7)
		
		if currWeekDay == 0 then
			currWeekDay = 7
		end
		
		--print("diffWeekDay: " .. tostring(diffWeekDay))
		--print("currWeekDay: " .. tostring(currWeekDay))
		
		if currWeekDay == 1 then
			weekDay = g_i18n:getText("showWeekDay1")
		elseif currWeekDay == 2 then
			weekDay = g_i18n:getText("showWeekDay2")
		elseif currWeekDay == 3 then
			weekDay = g_i18n:getText("showWeekDay3")
		elseif currWeekDay == 4 then
			weekDay = g_i18n:getText("showWeekDay4")
		elseif currWeekDay == 5 then
			weekDay = g_i18n:getText("showWeekDay5")
		elseif currWeekDay == 6 then
			weekDay = g_i18n:getText("showWeekDay6")
		elseif currWeekDay == 7 then
			weekDay = g_i18n:getText("showWeekDay7")
		end
		
		local myDate = mese .. ", " .. weekDay .. " " .. tostring(myDay)
		
		if DisplayDate4Seasons.formatDate == 2 then
			myDate = mese .. ", " .. weekDay
		elseif DisplayDate4Seasons.formatDate == 3 then
			myDate = string.format("%02d/%s", dayInSeason, mese) .. ", " .. weekDay
		elseif DisplayDate4Seasons.formatDate == 4 then
			myDate = string.format("%02d/%s", dayInSeason, mese)
		elseif DisplayDate4Seasons.formatDate == 5 then
			myDate = string.format("%02d/%s", dayInSeason, mese) .. ", " .. tostring(myYear)
		end
		
		g_seasons.ui.hud.dateText = myDate
		
		setTextWrapWidth(g_seasons.ui.hud.dateTextWrapWidth)
		setTextLineHeightScale(RenderText.DEFAULT_LINE_HEIGHT_SCALE)
		
		local height, numLines = getTextHeight(g_seasons.ui.hud.dateTextSize, g_seasons.ui.hud.dateText)
		g_seasons.ui.hud.dateTextHeight = height
		
		setTextLineHeightScale(RenderText.DEFAULT_LINE_HEIGHT_SCALE)
		setTextWrapWidth(0)
		
		--print("Period = " .. tostring(myPeriod))
		--print("daylight.latitude = " .. tostring(g_seasons.environment.daylight.latitude))
		--print("latitudeCategory = " .. tostring(g_seasons.environment:latitudeCategory()))
		
		--print("getCurrentVisualSeason = " .. tostring(g_seasons.environment:getCurrentVisualSeason(myPeriod)))
		--print("g_seasons.environment.season = " .. tostring(g_seasons.environment.season))
		
		if DisplayDate4Seasons.displaySeason then
			--local currentPeriod = g_seasons.environment.period
			local currentCategory = g_seasons.environment.latitudeCategories[g_seasons.environment:latitudeCategory()]
			local currentVisual = currentCategory[myPeriod]
			local visualSeasonsId = g_seasons.environment.seasonKeyToId[currentVisual]
			
			g_seasons.ui.hud:setSeason(visualSeasonsId)
		else
			g_seasons.ui.hud:setSeason(g_seasons.environment.season)
		end
		
	end
	
end